/*
  5 Temperaturen sollen angezeigt werden
  Alarmpiepser bei Anzeige der zu hohen Temperatur

  Pinbelegung:
  LCD:
   LCD D4 = D5
   LCD D5 = D4
   LCD D6 = D3
   LCD D7 = D2
   LCD RS = D12
   LCD R/W = D11
   LCD Enable = auf GND
   10K Widerstand:
   +5V und GND an Poti 
   Poti-Schleifer = VO 
  Sensoren (NTC 100KOhm):
  Sensor 1 = A0
  Sensor 2 = A1
  Sensor 3 = A2
  Sensor 4 = A3
  Sensor 5 = A4
*/

//Librarys einbinden
#include "Adafruit_LiquidCrystal.h"
Adafruit_LiquidCrystal lcd(11, 10, 5, 4, 3, 2);

int Speaker = 6;
byte HGLed  = 9;
int zaehler = 0;                   // fuer Anzeigeumschaltung
int zeit = 2000;

// Pinbelegung für den Nano
int SensorPin[5]    =  {A0, A1, A2, A3, A4}; // NTCs 0...5
// fuer Umrechnung in Grad Celsius
int    sensorWert[5];
double VBatt[5] = {5.0, 5.0, 5.0, 5.0, 5.0};                                                      // MUSS MAN Anpassen !
double B[6]  = {4300.0, 4300.0, 4300.0, 4300.0, 4300.0};                   // je nach NTC unterschiedlich !! ermitteln
double RNtc [5];                                                           // Messwert NTC
double RTeiler = 100000.0;                                                 // 100k Teiler
double RN = 100000.0;                                                      // 100kOhm-NTC
double TN = 298.15;                                                        // 25 Grad Celsision in Kelvin
double Vteiler[5];                                                         // Spannung am Teiler Rntc
double Temperatur[5];

//Setup
void setup() {
  //lcd.noDisplay();
  analogWrite (HGLed, 0);  
  lcd.begin(16, 2);
  lcd.clear();
  lcd.display();
  analogWrite (HGLed, 100);
  lcd.setCursor(0, 0);
  lcd.print("**** bereit ****");
  delay(2000);
}


// Arbeitsschleife
void loop() {
  int t;
  // Sensorwerte erfassen
  for (int t = 0; t <= 4; t++)
  {
    sensorWert[t] = analogRead(SensorPin[t]);                                     // Temperaturen einlesen
    Vteiler[t] = sensorWert[t] * 5.0 / 1023.0; // in Volt                         // Umrechnen in Widerstandwert
    RNtc[t] = (Vteiler[t] * RTeiler) / (VBatt[t] - Vteiler[t]);                      // Widerstand
    Temperatur[t] = ((B[t] * TN) / (B[t] + log(RNtc[t] / RN) * TN) - 273.15);           // Anzeige in Celsius
    delay(100);
  }
  // anzeigen
  if (zaehler == 0)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("erster Sensor : ");
    lcd.setCursor(0, 1);
    lcd.print(Temperatur[0]); lcd.print(" Grad");
    if (Temperatur[0] >= 80)                        // bei Ueberschreitung der Temp.-Grenze Ton ausgeben,
    {
      tone(Speaker, 1000, zeit);
    }
    delay (zeit);
  }
  if (zaehler == 1)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("zweiter Sensor : ");
    lcd.setCursor(0, 1);
    lcd.print(Temperatur[1]); lcd.print(" Grad");
    if (Temperatur[1] >= 80)                        // bei Ueberschreitung der Temp.-Grenze Ton ausgeben,
    {
      tone(Speaker, 1000, zeit);
    }
    delay (zeit);
  }
  if (zaehler == 2)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("dritter Sensor : ");
    lcd.setCursor(0, 1);
    lcd.print(Temperatur[2]); lcd.print(" Grad");
    if (Temperatur[2] >= 80)                        // bei Ueberschreitung der Temp.-Grenze Ton ausgeben,
    {
      tone(Speaker, 1000, zeit);
    }
    delay (zeit);
  }
  if (zaehler == 3)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("vierter Sensor : ");
    lcd.setCursor(0, 1);
    lcd.print(Temperatur[3]); lcd.print(" Grad");
    if (Temperatur[3] >= 80)                        // bei Ueberschreitung der Temp.-Grenze Ton ausgeben,
    {
      tone(Speaker, 1000, zeit);
    }
    delay (zeit);
  }
  if (zaehler == 4)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("f\365nfter Sensor : ");
    lcd.setCursor(0, 1);
    lcd.print(Temperatur[4]); lcd.print(" Grad");
    if (Temperatur[4] >= 80)                        // bei Ueberschreitung der Temp.-Grenze Ton ausgeben,
    {
      tone(Speaker, 1000, zeit);
    }
    delay (zeit);
  }
  zaehler++;
  if (zaehler >= 5) {
    zaehler = 0;
  }

}

